using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace NdisMonitor
{
	/// <summary>
	/// Summary description for OutputWindow.
	/// </summary>
	public class OutputWindow : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox ctrlOutput;
		private System.Windows.Forms.TextBox ctrlInput;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public OutputWindow()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(OutputWindow));
			this.ctrlOutput = new System.Windows.Forms.TextBox();
			this.ctrlInput = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// ctrlOutput
			// 
			this.ctrlOutput.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.ctrlOutput.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.ctrlOutput.Location = new System.Drawing.Point(0, 0);
			this.ctrlOutput.Multiline = true;
			this.ctrlOutput.Name = "ctrlOutput";
			this.ctrlOutput.ReadOnly = true;
			this.ctrlOutput.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.ctrlOutput.Size = new System.Drawing.Size(592, 345);
			this.ctrlOutput.TabIndex = 0;
			this.ctrlOutput.Text = "";
			this.ctrlOutput.WordWrap = false;
			// 
			// ctrlInput
			// 
			this.ctrlInput.AcceptsReturn = true;
			this.ctrlInput.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.ctrlInput.Location = new System.Drawing.Point(0, 348);
			this.ctrlInput.Name = "ctrlInput";
			this.ctrlInput.Size = new System.Drawing.Size(592, 20);
			this.ctrlInput.TabIndex = 1;
			this.ctrlInput.Text = "";
			this.ctrlInput.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.ctrlInput_KeyPress);
			// 
			// OutputWindow
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 368);
			this.Controls.Add(this.ctrlInput);
			this.Controls.Add(this.ctrlOutput);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "OutputWindow";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "output";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.OutputWindow_Closing);
			this.Load += new System.EventHandler(this.OutputWindow_Load);
			this.VisibleChanged += new System.EventHandler(this.OutputWindow_VisibleChanged);
			this.Activated += new System.EventHandler(this.OutputWindow_Activated);
			this.ResumeLayout(false);

		}
		#endregion

		//
		// Methods.
		//

		public void Add( string s )
		{
			ctrlOutput.AppendText( s + "\r\n" );
			ctrlOutput.SelectionStart = 0x7fffffff;
		}

		//
		// Data.
		//

		public NdisMonitor.ctrlForm			MainForm = null;

		protected bool						_visChanged = false;

		//
		// Handlers.
		//

		private void OutputWindow_Load(object sender, System.EventArgs e)
		{
			ctrlInput.Focus ();
		}

		private void OutputWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.Visible = false;
			e.Cancel = true;
		}

		private void OutputWindow_Activated(object sender, System.EventArgs e)
		{
			if ( _visChanged )
			{
				_visChanged = false;
				ctrlOutput.ScrollToCaret ();
			}

			ctrlInput.Focus ();
			return;
		}

		private void ctrlInput_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			char		c = e.KeyChar;
			if ( c == 0xD )
			{
				string			s = ctrlInput.Text;
				ctrlInput.Text = "";
				Add( ">" + s );

				e.Handled = true;

				if ( MainForm != null )
					MainForm.SubmitOutWinUserStr( s );
			}

			return;
		}

		private void OutputWindow_VisibleChanged(object sender, System.EventArgs e)
		{
			if ( Visible == true )
				_visChanged = true;
		}
	}
}
