using System;
using NdisMonitor;

class UserHook
{
	//
	// Called when a new packet arrives.
	//
	public bool ProcessNextPacket( ProcessNextPacketFn impl, LogFn log, RawPacket rp, NdisHookStubs.NEXT_PACKET np, int ord, DateTime tm )
	{
		//
		// Call the extension implementation.
		//
		// Here you can setup a filter for the new packets, for example. You can discard the
		// packets in which you are not interested, according to the source or destination
		// port, the IP protocol etc. etc. These are few examples:
		//
		// === EXAMPLE # 1 ===
		//   if ( rp is EthernetPacket && ((EthernetPacket)rp)._tranHeader is TranProt_TCP )
		//   {
		//     TranProt_TCP		tcp = (TranProt_TCP) ((EthernetPacket)rp)._tranHeader;
		//     if ( tcp._srcPort == 80 && np._bDirection == 0 /*RECV*/ )
		//       return impl( rp, np, ord, tm );
		//   }
		//   return false;
		//
		return impl( rp, np, ord, tm );
	}

	//
	// Called when the user enters a command in the output window.
	//
	public bool UserCommand( UserCommandFn impl, LogFn log, string s )
	{
		//
		// Call the extension implementation.
		// Here you can filter/manipulate/discard the string of the command entered.
		//
		return impl( s );
	}
}