using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace NdisMonitor
{
	/// <summary>
	/// Summary description for FilterWizCtrl04.
	/// </summary>
	public class FilterWizCtrl04 : System.Windows.Forms.UserControl, FilterWizard.IWizCtrl
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FilterWizCtrl04()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ctrlSeq = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.ctrlIsHex = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// ctrlSeq
			// 
			this.ctrlSeq.Location = new System.Drawing.Point(64, 56);
			this.ctrlSeq.Name = "ctrlSeq";
			this.ctrlSeq.Size = new System.Drawing.Size(208, 20);
			this.ctrlSeq.TabIndex = 2;
			this.ctrlSeq.Text = "";
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(64, 40);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(199, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Pattern (either a string or an HEX seq):";
			// 
			// ctrlIsHex
			// 
			this.ctrlIsHex.Location = new System.Drawing.Point(184, 112);
			this.ctrlIsHex.Name = "ctrlIsHex";
			this.ctrlIsHex.Size = new System.Drawing.Size(168, 48);
			this.ctrlIsHex.TabIndex = 4;
			this.ctrlIsHex.Text = "String is an HEX sequence (i.e. \"CCDDEEFF00 ...\")";
			// 
			// FilterWizCtrl04
			// 
			this.Controls.Add(this.ctrlIsHex);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.ctrlSeq);
			this.Name = "FilterWizCtrl04";
			this.Size = new System.Drawing.Size(360, 168);
			this.ResumeLayout(false);

		}
		#endregion

		private System.Windows.Forms.TextBox ctrlSeq;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.CheckBox ctrlIsHex;


		FilterWizard.SWizCtrl			_info;

		void FilterWizard.IWizCtrl.Init ( FilterWizard.SWizCtrl info )
		{
			_info = info;
		}

		void FilterWizard.IWizCtrl.Generate ( TextBox tb )
		{
			if ( ctrlSeq.Text.Length != 0 )
			{
				// compose.

				string			text = "";

				text += "for( int i=0; i<rp._data.Length-" +
					(ctrlSeq.Text.Length / (ctrlIsHex.Checked ? 2 : 1) - 1).ToString () +
					"; i++ )\r\n";
				text += "  if ( ";

				if ( ctrlIsHex.Checked == false )
				{
					// compose non-hex text.
					int			index = 0;
					foreach( char c in ctrlSeq.Text )
					{
						if ( index != 0 )
							text += " && ";
						text += "rp._data[i+" + index.ToString () + "] == '" + c + "'";
						index ++;
					}
				}
				else
				{
					// compose hex text.
					for( int i=0; i<ctrlSeq.Text.Length; i += 2 )
					{
						string			hex = "0x" + ctrlSeq.Text.Substring( i, 2 ).ToUpper ();
						if ( i != 0 )
							text += " && ";
						text += "rp._data[i+" + (i/2).ToString () + "] == " + hex;
					}
				}

				text += " )\r\n";
				text += "    return impl( rp, np, ord, tm );\r\n";
				text += "return false;\r\n";

				// set.
				tb.SelectedText = text;
				tb.Modified = true;
			}
		}
	}
}
